//Package 

package onKeyHitEvent
{
	//fxDTSBrick Methods

	function fxDTSBrick::keyCheck(%obj,%accessType,%blidList,%client)
	{
		switch(%accessType)
		{
			case 0:
				%obj.keyCheckUnrestricted(%client);
			case 1:
				%obj.keyCheckAnyAdmin(%client);
			case 2:
				%obj.keyCheckAdmin(%client);
			case 3:
				%obj.keyCheckSuperAdmin(%client);
			case 4:
				%obj.keyCheckBLIDEquals(%blidList,%client);
			case 5:
				%obj.keyCheckBLIDNEquals(%blidList,%client);
			case 6:
				%obj.keyCheckInMinigame(%client);
			case 7:
				%obj.keyCheckAllTrust(%client);
			case 8:
				%obj.keyCheckTrustLevel1(%client);
			case 9:
				%obj.keyCheckTrustLevel2(%client);
		}	
	}

	function fxDTSBrick::keyCheckUnrestricted(%obj,%client)
	{
		%obj.onKeySuccess(%client);
	}
	
	function fxDTSBrick::keyCheckAnyAdmin(%obj,%client)
	{                  	
		if(%client.isAdmin == 1 || %client.isSuperAdmin == 1)
		{
			%obj.onKeySuccess(%client);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckAdmin(%obj,%client)
	{                  	
		if(%client.isAdmin == 1 && %client.isSuperAdmin == 0)
		{
			%obj.onKeySuccess(%client);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckSuperAdmin(%obj,%client)
	{                  	
		if(%client.isSuperAdmin == 1)
		{
			%obj.onKeySuccess(%client);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckBLIDEquals(%obj,%blidList,%client)
	{
		if(%blidList !$= "")
		{
			%ids = 0;

			for(%i = 0;%i < getWordCount(%blidList);%i++)
			{
				%word = getWord(%blidList,%i);
				%fail = 0;

				for(%j = 0;%j < strlen(%word);%j++)
				{
					%char = getSubStr(%word,%j,1);

					if(strstr("1234567890",%char) == -1)
					{
						%fail = 1;
					}
				}

				if(!%fail)
				{
					%id[%ids++] = %word;
				}
			}

			%allow = 0;

			for(%i = 1;%i <= %ids;%i++)
			{
				%blid = %id[%i];

				if(%blid == %client.BL_ID)
				{
					%allow = 1;
					break;
				}
			}

			if(%allow == 1)
			{
				%obj.onKeySuccess(%client);
			}
			else
			{
				%obj.onKeyFailure(%client);
			}
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckBLIDNEquals(%obj,%blidList,%client)
	{
		if(%blidList !$= "")
		{
			%ids = 0;

			for(%i = 0;%i < getWordCount(%blidList);%i++)
			{
				%word = getWord(%blidList,%i);
				%fail = 0;

				for(%j = 0;%j < strlen(%word);%j++)
				{
					%char = getSubStr(%word,%j,1);

					if(strstr("1234567890",%char) == -1)
					{
						%fail = 1;
					}
				}

				if(!%fail)
				{
					%id[%ids++] = %word;
				}
			}

			%allow = 0;

			for(%i = 1;%i <= %ids;%i++)
			{
				%blid = %id[%i];

				if(%blid == %client.BL_ID)
				{
					%allow = 1;
					break;
				}
			}

			if(%allow == 1)
			{
				%obj.onKeyFailure(%client);
			}
			else
			{
				%obj.onKeySuccess(%client);
			}
		}
		else
		{
			%obj.onKeySuccess(%client);
		}
	}

	function fxDTSBrick::keyCheckInMinigame(%obj,%client)
	{
		if(miniGameCanUse(%client,%obj) == 1)
		{
			%obj.onKeySuccess(%client);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckAllTrust(%obj,%client)
	{
		if(getTrustLevel(%client,%obj) >= 1)
		{
			%obj.onKeySuccess(%client);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckTrustLevel1(%obj,%client)
	{
		if(getTrustLevel(%client,%obj) == 1)
		{
			%obj.onKeySuccess(%client);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::keyCheckTrustLevel2(%obj,%client)
	{
		if(getTrustLevel(%client,%obj) >= 2)
		{
			%obj.onKeySuccess(%client);
		}
		else
		{
			%obj.onKeyFailure(%client);
		}
	}

	function fxDTSBrick::onKeyHit(%this, %client)
	{
		$inputTarget_self = %this;
		$inputTarget_client = %client;
		$inputTarget_player = %client.player;
		$inputTarget_miniGame = getMiniGameFromObject(%this);
		%this.processInputEvent("onKeyHit", %client);
	}

	function fxDTSBrick::onKeySuccess(%this, %client)
	{
		$inputTarget_self = %this;
		$inputTarget_client = %client;
		$inputTarget_player = %client.player;
		$inputTarget_miniGame = getMiniGameFromObject(%this);
		%this.processInputEvent("onKeySuccess", %client);
	}

	function fxDTSBrick::onKeyFailure(%this, %client)
	{
		$inputTarget_self = %this;
		$inputTarget_client = %client;
		$inputTarget_player = %client.player;
		$inputTarget_miniGame = getMiniGameFromObject(%this);
		%this.processInputEvent("onKeyFailure", %client);
	}

	//keyProjectile Methods

	function keyProjectile::OnCollision(%this,%obj,%col,%fade,%pos,%normal)
	{
		if(%col.getClassName() $= "fxDtsBrick")
		{
			%col.onKeyHit(%obj.sourceObject.client);
		}
	}
};

ActivatePackage(onKeyHitEvent);

//Input Events

registerInputEvent("fxDTSBrick","onKeySuccess","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame",1);
registerInputEvent("fxDTSBrick","onKeyFailure","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame",1);
registerInputEvent("fxDTSBrick","onKeyHit","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame",1);

//Output Events

registerOutputEvent("fxDTSBrick","keyCheck","list Unrestricted 0 Any-Admin 1 Admin 2 SuperAdmin 3 BLID-Includes 4 BLID-Excludes 5 InMiniGame 6 Any-Trust 7 BuildTrust 8 FullTrust-Self 9" TAB "string 200 72",1);